import { NgModule } from "@angular/core";
import { RouterModule, Routes } from "@angular/router";
import { AboutCompComponent } from "./components/about-comp/about-comp.component";
import { CpcqFormComponent } from "./components/cpcq-form/cpcq-form.component";
import { DashboardComponent } from "./components/dashboard/dashboard.component";
import { FinalDashboardComponent } from "./components/final-dashboard/final-dashboard.component";
import { FinalFeedbackComponent } from "./components/final-feedback/final-feedback.component";
import { GraphPageComponent } from "./components/graph-page/graph-page.component";
import { HomePageComponent } from "./components/home-page/home-page.component";
import { PostSurveyComponent } from "./components/post-survey/post-survey.component";
import { PreSurveyComponent } from "./components/pre-survey/pre-survey.component";
import { RegisterComponentComponent } from "./components/register-component/register-component.component";
import { ResultDashboardComponent } from "./components/result-dashboard/result-dashboard.component";
import { ScorePageComponent } from "./components/score-page/score-page.component";
import { UnpackingPageComponent } from "./components/unpacking-page/unpacking-page.component";
import { LandingPageGuard } from "./guards/landing-page.guard";
import { RoleGuard } from "./guards/role.guard";

const routes: Routes = [
  { path: "", canActivate: [LandingPageGuard], component: HomePageComponent },
  { path: "about", component: AboutCompComponent },
  { path: "preSurvey", canActivate: [RoleGuard], component: PreSurveyComponent },
  { path: "pcqform", canActivate: [RoleGuard], component: CpcqFormComponent },
  { path: "postSurvey", canActivate: [RoleGuard], component: PostSurveyComponent },
  { path: "dashboard", canActivate: [RoleGuard], component: DashboardComponent },
  { path: "result", canActivate: [RoleGuard], component: ResultDashboardComponent },
  { path: "register", canActivate: [RoleGuard], component: RegisterComponentComponent },
  { path: "score", canActivate: [RoleGuard], component: ScorePageComponent },
  { path: "graph", canActivate: [RoleGuard], component: GraphPageComponent },
  { path: "final", canActivate: [RoleGuard], component: FinalDashboardComponent },
  { path: "unpacking", canActivate: [RoleGuard], component: UnpackingPageComponent },
  { path: "finalFeedback", canActivate: [RoleGuard], component: FinalFeedbackComponent },
];

@NgModule({
  imports: [RouterModule.forRoot(routes, { relativeLinkResolution: "legacy" })],
  exports: [RouterModule],
})
export class AppRoutingModule {}
