import { AfterViewInit, Component, ElementRef, OnInit, ViewChild } from "@angular/core";
import { UntypedFormBuilder, UntypedFormGroup, Validators } from "@angular/forms";
import { ThemePalette } from "@angular/material/core";
import { MatDialog } from "@angular/material/dialog";
import { ProgressBarMode } from "@angular/material/progress-bar";
import { DomSanitizer } from "@angular/platform-browser";
import { Router } from "@angular/router";
import * as RecordRTC from "recordrtc";
import { FirstForm } from "src/app/services/firstForm.service";
import Swal from "sweetalert2";
import { DialogFormComponent } from "./dialog-form/dialog-form.component";
declare var $: any;

import { CPCQService } from "src/app/services/cpcq.service";

export interface DialogData {
  animal: "panda" | "unicorn" | "lion";
  status;
  result;
}
@Component({
  selector: "app-cpcq-form",
  templateUrl: "./cpcq-form.component.html",
  styleUrls: ["./cpcq-form.component.css"],
})
export class CpcqFormComponent implements OnInit, AfterViewInit {
  firstForm: UntypedFormGroup;
  responseList: any;
  loaded = false;

  questionArray = [
    ["Enter First Name", "text"],
    ["Enter Last Name", "text"],
    ["Enter Age", "number"],
  ];
  statusCheck = false;
  buttonClick = false;

  sliderValue = 0;

  selectedIndex = 0;

  color: ThemePalette = "primary";
  mode: ProgressBarMode = "buffer";
  value1 = 50;
  bufferValue = 100;

  formValues = [];
  attributes = ["Attitude", "Empathy", "Policy", "Professionalism", "Teaching Practice"];
  columnHeadings = [
    "culturalDestructivenessresponse",
    "culturalIncapacityresponse",
    "culturalBlindnessresponse",
    "culturalPreCompetenceresponse",
    "culturalCompetenceresponse",
    "culturalProficiencyresponse",
  ];
  rowLetters = [
    ["D", "C", "B", "A", "F", "E"],
    ["E", "A", "F", "D", "B", "C"],
    ["F", "E", "B", "C", "D", "A"],
    ["E", "A", "B", "D", "C", "F"],
    ["D", "C", "B", "E", "A", "F"],
  ];
  boldList = [[]];
  randomList = [[]];
  finalList = [[]];
  finalList1 = [];
  attitudeForm: UntypedFormGroup;
  empathyForm: UntypedFormGroup;
  policyForm: UntypedFormGroup;

  finalFeedbackForm: UntypedFormGroup;

  //arrays of data getting from the backend

  attitude: any;
  empathy: any;
  policy: any;
  professionalism: any;
  teachingPractice: any;
  wordDescription: any;
  unpackedCount = 0;

  startTime: any;
  endTime: any;
  durationTime: any;

  @ViewChild("changeDiv") changeDiv: ElementRef;
  @ViewChild("changeDiv1") changeDiv1: ElementRef;
  @ViewChild("changeDiv2") changeDiv2: ElementRef;
  @ViewChild("changeDiv3") changeDiv3: ElementRef;
  @ViewChild("changeDiv4") changeDiv4: ElementRef;
  @ViewChild("changeDiv5") changeDiv5: ElementRef;
  @ViewChild("changeDiv6") changeDiv6: ElementRef;
  @ViewChild("changeDiv7") changeDiv7: ElementRef;
  @ViewChild("changeDiv8") changeDiv8: ElementRef;
  @ViewChild("changeDiv9") changeDiv9: ElementRef;
  @ViewChild("changeDiv10") changeDiv10: ElementRef;
  @ViewChild("changeDiv11") changeDiv11: ElementRef;
  @ViewChild("changeDiv12") changeDiv12: ElementRef;
  @ViewChild("changeDiv13") changeDiv13: ElementRef;
  @ViewChild("changeDiv14") changeDiv14: ElementRef;
  @ViewChild("changeDiv15") changeDiv15: ElementRef;
  @ViewChild("changeDiv16") changeDiv16: ElementRef;
  @ViewChild("changeDiv17") changeDiv17: ElementRef;
  @ViewChild("changeDiv18") changeDiv18: ElementRef;
  @ViewChild("changeDiv19") changeDiv19: ElementRef;
  @ViewChild("changeDiv20") changeDiv20: ElementRef;
  @ViewChild("changeDiv21") changeDiv21: ElementRef;
  @ViewChild("changeDiv22") changeDiv22: ElementRef;
  @ViewChild("changeDiv23") changeDiv23: ElementRef;
  @ViewChild("changeDiv24") changeDiv24: ElementRef;
  @ViewChild("changeDiv25") changeDiv25: ElementRef;
  @ViewChild("changeDiv26") changeDiv26: ElementRef;
  @ViewChild("changeDiv27") changeDiv27: ElementRef;
  @ViewChild("changeDiv28") changeDiv28: ElementRef;
  @ViewChild("changeDiv29") changeDiv29: ElementRef;

  ngAfterViewInit() {}

  sliderFunction1() {
    if (this.sliderValue == 1) {
      this.changeDiv.nativeElement.style.fontSize = "15px";
      this.changeDiv1.nativeElement.style.fontSize = "15px";
      this.changeDiv2.nativeElement.style.fontSize = "15px";
      this.changeDiv3.nativeElement.style.fontSize = "15px";
      this.changeDiv4.nativeElement.style.fontSize = "15px";
      this.changeDiv5.nativeElement.style.fontSize = "15px";
      this.changeDiv6.nativeElement.style.fontSize = "15px";
      this.changeDiv7.nativeElement.style.fontSize = "15px";
      this.changeDiv8.nativeElement.style.fontSize = "15px";
      this.changeDiv9.nativeElement.style.fontSize = "15px";
      this.changeDiv10.nativeElement.style.fontSize = "15px";
      this.changeDiv11.nativeElement.style.fontSize = "15px";
      this.changeDiv12.nativeElement.style.fontSize = "15px";
      this.changeDiv13.nativeElement.style.fontSize = "15px";
      this.changeDiv14.nativeElement.style.fontSize = "15px";
      this.changeDiv15.nativeElement.style.fontSize = "15px";
      this.changeDiv16.nativeElement.style.fontSize = "15px";
      this.changeDiv17.nativeElement.style.fontSize = "15px";
      this.changeDiv18.nativeElement.style.fontSize = "15px";
      this.changeDiv19.nativeElement.style.fontSize = "15px";
      this.changeDiv20.nativeElement.style.fontSize = "15px";
      this.changeDiv21.nativeElement.style.fontSize = "15px";
      this.changeDiv22.nativeElement.style.fontSize = "15px";
      this.changeDiv23.nativeElement.style.fontSize = "15px";
      this.changeDiv24.nativeElement.style.fontSize = "15px";
      this.changeDiv25.nativeElement.style.fontSize = "15px";
      this.changeDiv26.nativeElement.style.fontSize = "15px";
      this.changeDiv27.nativeElement.style.fontSize = "15px";
      this.changeDiv28.nativeElement.style.fontSize = "15px";
      this.changeDiv29.nativeElement.style.fontSize = "15px";
    } else if (this.sliderValue == 2) {
      this.changeDiv.nativeElement.style.fontSize = "20px";
      this.changeDiv1.nativeElement.style.fontSize = "20px";
      this.changeDiv2.nativeElement.style.fontSize = "20px";
      this.changeDiv3.nativeElement.style.fontSize = "20px";
      this.changeDiv4.nativeElement.style.fontSize = "20px";
      this.changeDiv5.nativeElement.style.fontSize = "20px";
      this.changeDiv6.nativeElement.style.fontSize = "20px";
      this.changeDiv7.nativeElement.style.fontSize = "20px";
      this.changeDiv8.nativeElement.style.fontSize = "20px";
      this.changeDiv9.nativeElement.style.fontSize = "20px";
      this.changeDiv10.nativeElement.style.fontSize = "20px";
      this.changeDiv11.nativeElement.style.fontSize = "20px";
      this.changeDiv12.nativeElement.style.fontSize = "20px";
      this.changeDiv13.nativeElement.style.fontSize = "20px";
      this.changeDiv14.nativeElement.style.fontSize = "20px";
      this.changeDiv15.nativeElement.style.fontSize = "20px";
      this.changeDiv16.nativeElement.style.fontSize = "20px";
      this.changeDiv17.nativeElement.style.fontSize = "20px";
      this.changeDiv18.nativeElement.style.fontSize = "20px";
      this.changeDiv19.nativeElement.style.fontSize = "20px";
      this.changeDiv20.nativeElement.style.fontSize = "20px";
      this.changeDiv21.nativeElement.style.fontSize = "20px";
      this.changeDiv22.nativeElement.style.fontSize = "20px";
      this.changeDiv23.nativeElement.style.fontSize = "20px";
      this.changeDiv24.nativeElement.style.fontSize = "20px";
      this.changeDiv25.nativeElement.style.fontSize = "20px";
      this.changeDiv26.nativeElement.style.fontSize = "20px";
      this.changeDiv27.nativeElement.style.fontSize = "20px";
      this.changeDiv28.nativeElement.style.fontSize = "20px";
      this.changeDiv29.nativeElement.style.fontSize = "20px";
    } else if (this.sliderValue == 3) {
      this.changeDiv.nativeElement.style.fontSize = "22px";
      this.changeDiv1.nativeElement.style.fontSize = "22px";
      this.changeDiv2.nativeElement.style.fontSize = "22px";
      this.changeDiv3.nativeElement.style.fontSize = "22px";
      this.changeDiv4.nativeElement.style.fontSize = "22px";
      this.changeDiv5.nativeElement.style.fontSize = "22px";
      this.changeDiv6.nativeElement.style.fontSize = "22px";
      this.changeDiv7.nativeElement.style.fontSize = "22px";
      this.changeDiv8.nativeElement.style.fontSize = "22px";
      this.changeDiv9.nativeElement.style.fontSize = "22px";
      this.changeDiv10.nativeElement.style.fontSize = "22px";
      this.changeDiv11.nativeElement.style.fontSize = "22px";
      this.changeDiv12.nativeElement.style.fontSize = "22px";
      this.changeDiv13.nativeElement.style.fontSize = "22px";
      this.changeDiv14.nativeElement.style.fontSize = "22px";
      this.changeDiv15.nativeElement.style.fontSize = "22px";
      this.changeDiv16.nativeElement.style.fontSize = "22px";
      this.changeDiv17.nativeElement.style.fontSize = "22px";
      this.changeDiv18.nativeElement.style.fontSize = "22px";
      this.changeDiv19.nativeElement.style.fontSize = "22px";
      this.changeDiv20.nativeElement.style.fontSize = "22px";
      this.changeDiv21.nativeElement.style.fontSize = "22px";
      this.changeDiv22.nativeElement.style.fontSize = "22px";
      this.changeDiv23.nativeElement.style.fontSize = "22px";
      this.changeDiv24.nativeElement.style.fontSize = "22px";
      this.changeDiv25.nativeElement.style.fontSize = "22px";
      this.changeDiv26.nativeElement.style.fontSize = "22px";
      this.changeDiv27.nativeElement.style.fontSize = "22px";
      this.changeDiv28.nativeElement.style.fontSize = "22px";
      this.changeDiv29.nativeElement.style.fontSize = "22px";
    } else if (this.sliderValue == 4) {
      this.changeDiv.nativeElement.style.fontSize = "25px";
      this.changeDiv1.nativeElement.style.fontSize = "25px";
      this.changeDiv2.nativeElement.style.fontSize = "25px";
      this.changeDiv3.nativeElement.style.fontSize = "25px";
      this.changeDiv4.nativeElement.style.fontSize = "25px";
      this.changeDiv5.nativeElement.style.fontSize = "25px";
      this.changeDiv6.nativeElement.style.fontSize = "25px";
      this.changeDiv7.nativeElement.style.fontSize = "25px";
      this.changeDiv8.nativeElement.style.fontSize = "25px";
      this.changeDiv9.nativeElement.style.fontSize = "25px";
      this.changeDiv10.nativeElement.style.fontSize = "25px";
      this.changeDiv11.nativeElement.style.fontSize = "25px";
      this.changeDiv12.nativeElement.style.fontSize = "25px";
      this.changeDiv13.nativeElement.style.fontSize = "25px";
      this.changeDiv14.nativeElement.style.fontSize = "25px";
      this.changeDiv15.nativeElement.style.fontSize = "25px";
      this.changeDiv16.nativeElement.style.fontSize = "25px";
      this.changeDiv17.nativeElement.style.fontSize = "25px";
      this.changeDiv18.nativeElement.style.fontSize = "25px";
      this.changeDiv19.nativeElement.style.fontSize = "25px";
      this.changeDiv20.nativeElement.style.fontSize = "25px";
      this.changeDiv21.nativeElement.style.fontSize = "25px";
      this.changeDiv22.nativeElement.style.fontSize = "25px";
      this.changeDiv23.nativeElement.style.fontSize = "25px";
      this.changeDiv24.nativeElement.style.fontSize = "25px";
      this.changeDiv25.nativeElement.style.fontSize = "25px";
      this.changeDiv26.nativeElement.style.fontSize = "25px";
      this.changeDiv27.nativeElement.style.fontSize = "25px";
      this.changeDiv28.nativeElement.style.fontSize = "25px";
      this.changeDiv29.nativeElement.style.fontSize = "25px";
    } else if (this.sliderValue == 5) {
      this.changeDiv.nativeElement.style.fontSize = "50px";
      this.changeDiv1.nativeElement.style.fontSize = "50px";
      this.changeDiv2.nativeElement.style.fontSize = "50px";
      this.changeDiv3.nativeElement.style.fontSize = "50px";
      this.changeDiv4.nativeElement.style.fontSize = "50px";
      this.changeDiv5.nativeElement.style.fontSize = "50px";
    }
  }
  sliderFunction(e) {
    //
    this.sliderValue = e.value;
    if (e.value == 1) {
      this.changeDiv.nativeElement.style.fontSize = "15px";
      this.changeDiv1.nativeElement.style.fontSize = "15px";
      this.changeDiv2.nativeElement.style.fontSize = "15px";
      this.changeDiv3.nativeElement.style.fontSize = "15px";
      this.changeDiv4.nativeElement.style.fontSize = "15px";
      this.changeDiv5.nativeElement.style.fontSize = "15px";
      this.changeDiv6.nativeElement.style.fontSize = "15px";
      this.changeDiv7.nativeElement.style.fontSize = "15px";
      this.changeDiv8.nativeElement.style.fontSize = "15px";
      this.changeDiv9.nativeElement.style.fontSize = "15px";
      this.changeDiv10.nativeElement.style.fontSize = "15px";
      this.changeDiv11.nativeElement.style.fontSize = "15px";
      this.changeDiv12.nativeElement.style.fontSize = "15px";
      this.changeDiv13.nativeElement.style.fontSize = "15px";
      this.changeDiv14.nativeElement.style.fontSize = "15px";
      this.changeDiv15.nativeElement.style.fontSize = "15px";
      this.changeDiv16.nativeElement.style.fontSize = "15px";
      this.changeDiv17.nativeElement.style.fontSize = "15px";
      this.changeDiv18.nativeElement.style.fontSize = "15px";
      this.changeDiv19.nativeElement.style.fontSize = "15px";
      this.changeDiv20.nativeElement.style.fontSize = "15px";
      this.changeDiv21.nativeElement.style.fontSize = "15px";
      this.changeDiv22.nativeElement.style.fontSize = "15px";
      this.changeDiv23.nativeElement.style.fontSize = "15px";
      this.changeDiv24.nativeElement.style.fontSize = "15px";
      this.changeDiv25.nativeElement.style.fontSize = "15px";
      this.changeDiv26.nativeElement.style.fontSize = "15px";
      this.changeDiv27.nativeElement.style.fontSize = "15px";
      this.changeDiv28.nativeElement.style.fontSize = "15px";
      this.changeDiv29.nativeElement.style.fontSize = "15px";
    } else if (e.value == 2) {
      this.changeDiv.nativeElement.style.fontSize = "20px";
      this.changeDiv1.nativeElement.style.fontSize = "20px";
      this.changeDiv2.nativeElement.style.fontSize = "20px";
      this.changeDiv3.nativeElement.style.fontSize = "20px";
      this.changeDiv4.nativeElement.style.fontSize = "20px";
      this.changeDiv5.nativeElement.style.fontSize = "20px";
      this.changeDiv6.nativeElement.style.fontSize = "20px";
      this.changeDiv7.nativeElement.style.fontSize = "20px";
      this.changeDiv8.nativeElement.style.fontSize = "20px";
      this.changeDiv9.nativeElement.style.fontSize = "20px";
      this.changeDiv10.nativeElement.style.fontSize = "20px";
      this.changeDiv11.nativeElement.style.fontSize = "20px";
      this.changeDiv12.nativeElement.style.fontSize = "20px";
      this.changeDiv13.nativeElement.style.fontSize = "20px";
      this.changeDiv14.nativeElement.style.fontSize = "20px";
      this.changeDiv15.nativeElement.style.fontSize = "20px";
      this.changeDiv16.nativeElement.style.fontSize = "20px";
      this.changeDiv17.nativeElement.style.fontSize = "20px";
      this.changeDiv18.nativeElement.style.fontSize = "20px";
      this.changeDiv19.nativeElement.style.fontSize = "20px";
      this.changeDiv20.nativeElement.style.fontSize = "20px";
      this.changeDiv21.nativeElement.style.fontSize = "20px";
      this.changeDiv22.nativeElement.style.fontSize = "20px";
      this.changeDiv23.nativeElement.style.fontSize = "20px";
      this.changeDiv24.nativeElement.style.fontSize = "20px";
      this.changeDiv25.nativeElement.style.fontSize = "20px";
      this.changeDiv26.nativeElement.style.fontSize = "20px";
      this.changeDiv27.nativeElement.style.fontSize = "20px";
      this.changeDiv28.nativeElement.style.fontSize = "20px";
      this.changeDiv29.nativeElement.style.fontSize = "20px";
    } else if (e.value == 3) {
      this.changeDiv.nativeElement.style.fontSize = "22px";
      this.changeDiv1.nativeElement.style.fontSize = "22px";
      this.changeDiv2.nativeElement.style.fontSize = "22px";
      this.changeDiv3.nativeElement.style.fontSize = "22px";
      this.changeDiv4.nativeElement.style.fontSize = "22px";
      this.changeDiv5.nativeElement.style.fontSize = "22px";
      this.changeDiv6.nativeElement.style.fontSize = "22px";
      this.changeDiv7.nativeElement.style.fontSize = "22px";
      this.changeDiv8.nativeElement.style.fontSize = "22px";
      this.changeDiv9.nativeElement.style.fontSize = "22px";
      this.changeDiv10.nativeElement.style.fontSize = "22px";
      this.changeDiv11.nativeElement.style.fontSize = "22px";
      this.changeDiv12.nativeElement.style.fontSize = "22px";
      this.changeDiv13.nativeElement.style.fontSize = "22px";
      this.changeDiv14.nativeElement.style.fontSize = "22px";
      this.changeDiv15.nativeElement.style.fontSize = "22px";
      this.changeDiv16.nativeElement.style.fontSize = "22px";
      this.changeDiv17.nativeElement.style.fontSize = "22px";
      this.changeDiv18.nativeElement.style.fontSize = "22px";
      this.changeDiv19.nativeElement.style.fontSize = "22px";
      this.changeDiv20.nativeElement.style.fontSize = "22px";
      this.changeDiv21.nativeElement.style.fontSize = "22px";
      this.changeDiv22.nativeElement.style.fontSize = "22px";
      this.changeDiv23.nativeElement.style.fontSize = "22px";
      this.changeDiv24.nativeElement.style.fontSize = "22px";
      this.changeDiv25.nativeElement.style.fontSize = "22px";
      this.changeDiv26.nativeElement.style.fontSize = "22px";
      this.changeDiv27.nativeElement.style.fontSize = "22px";
      this.changeDiv28.nativeElement.style.fontSize = "22px";
      this.changeDiv29.nativeElement.style.fontSize = "22px";
    } else if (e.value == 4) {
      this.changeDiv.nativeElement.style.fontSize = "25px";
      this.changeDiv1.nativeElement.style.fontSize = "25px";
      this.changeDiv2.nativeElement.style.fontSize = "25px";
      this.changeDiv3.nativeElement.style.fontSize = "25px";
      this.changeDiv4.nativeElement.style.fontSize = "25px";
      this.changeDiv5.nativeElement.style.fontSize = "25px";
      this.changeDiv6.nativeElement.style.fontSize = "25px";
      this.changeDiv7.nativeElement.style.fontSize = "25px";
      this.changeDiv8.nativeElement.style.fontSize = "25px";
      this.changeDiv9.nativeElement.style.fontSize = "25px";
      this.changeDiv10.nativeElement.style.fontSize = "25px";
      this.changeDiv11.nativeElement.style.fontSize = "25px";
      this.changeDiv12.nativeElement.style.fontSize = "25px";
      this.changeDiv13.nativeElement.style.fontSize = "25px";
      this.changeDiv14.nativeElement.style.fontSize = "25px";
      this.changeDiv15.nativeElement.style.fontSize = "25px";
      this.changeDiv16.nativeElement.style.fontSize = "25px";
      this.changeDiv17.nativeElement.style.fontSize = "25px";
      this.changeDiv18.nativeElement.style.fontSize = "25px";
      this.changeDiv19.nativeElement.style.fontSize = "25px";
      this.changeDiv20.nativeElement.style.fontSize = "25px";
      this.changeDiv21.nativeElement.style.fontSize = "25px";
      this.changeDiv22.nativeElement.style.fontSize = "25px";
      this.changeDiv23.nativeElement.style.fontSize = "25px";
      this.changeDiv24.nativeElement.style.fontSize = "25px";
      this.changeDiv25.nativeElement.style.fontSize = "25px";
      this.changeDiv26.nativeElement.style.fontSize = "25px";
      this.changeDiv27.nativeElement.style.fontSize = "25px";
      this.changeDiv28.nativeElement.style.fontSize = "25px";
      this.changeDiv29.nativeElement.style.fontSize = "25px";
    } else if (e.value == 5) {
      this.changeDiv.nativeElement.style.fontSize = "50px";
      this.changeDiv1.nativeElement.style.fontSize = "50px";
      this.changeDiv2.nativeElement.style.fontSize = "50px";
      this.changeDiv3.nativeElement.style.fontSize = "50px";
      this.changeDiv4.nativeElement.style.fontSize = "50px";
      this.changeDiv5.nativeElement.style.fontSize = "50px";
    }
  }
  constructor(
    private fb: UntypedFormBuilder,
    private apiService: CPCQService,
    private router: Router,
    private formService: FirstForm,
    private domSanitizer: DomSanitizer,
    public dialog: MatDialog
  ) {}
  openDialog(i, j, id) {
    //

    var arr = [];
    arr.push(this.attributes[i]);
    arr.push(j);
    arr.push(this.columnHeadings[j]);
    arr.push(id);
    const dialogRef = this.dialog.open(DialogFormComponent, {
      data: {
        animal: arr,
        status: "form",
      },
      disableClose: true,
    });
    dialogRef.afterClosed().subscribe((result) => {
      if (this.responsesArray[i][j][1] == "colorbold") {
        this.unpackedCount = this.unpackedCount + 1;
      }
    });
  }

  openWordDialog(i) {
    //
    this.buttonClick = true;
    const dialogRef = this.dialog.open(DialogFormComponent, {
      data: {
        animal: i,
        status: "word",
      },
      disableClose: true,
    });

    dialogRef.afterClosed().subscribe((result) => {
      this.wordDescription = result;
    });
  }

  helpDialog(i) {
    //
    this.dialog.open(DialogFormComponent, {
      data: {
        animal: i,
        status: "help",
      },
    });
  }

  keyPressFunc(e) {
    //
    var numbersList = ["1"];
    for (let key in this.attitudeForm.value) {
      if (numbersList.indexOf(this.attitudeForm.value[key]) == -1) {
        //
        return "Number";
      }
    }
  }

  getEmailError() {
    return "Error";
  }
  responsesArray = [];
  temp = [];
  getResponses() {
    this.apiService.getResponsesData().subscribe((res) => {
      for (let key in res) {
        this.temp = [];
        for (let key1 in res[key]) {
          this.temp.push(res[key][key1]);
        }
        this.responsesArray.push(this.temp);
      }
    });
  }

  getForm() {
    var arr = [];
    var arr1 = [];
    var arr2 = [];
    var i;
    var attitudeResult = [];
    var empathyResult = [];
    var policyResult = [];
    var profResult = [];
    var teachingResult = [];
    this.finalList = [[]];
    this.boldList = [[]];
    this.apiService.getFormData().subscribe((res) => {
      for (let key in res) {
        arr = [];
        if (res[key]["topic"] == "Attitude") {
          attitudeResult.push("Attitude");
          arr.push("Attitude");
          arr.push(res[key]["culturalDestructiveness"]);
          arr.push(res[key]["culturalIncapacity"]);
          arr.push(res[key]["culturalBlindness"]);
          arr.push(res[key]["culturalPreCompetence"]);
          arr.push(res[key]["culturalCompetence"]);
          arr.push(res[key]["culturalProficiency"]);

          attitudeResult.push(Math.abs(parseInt(res[key]["culturalDestructiveness"].split(".")[1]) - 1) >= 2 ? 1 : 0);
          attitudeResult.push(Math.abs(parseInt(res[key]["culturalIncapacity"].split(".")[1]) - 2) >= 2 ? 1 : 0);
          attitudeResult.push(Math.abs(parseInt(res[key]["culturalBlindness"].split(".")[1]) - 3) >= 2 ? 1 : 0);
          attitudeResult.push(Math.abs(parseInt(res[key]["culturalPreCompetence"].split(".")[1]) - 4) >= 2 ? 1 : 0);
          attitudeResult.push(Math.abs(parseInt(res[key]["culturalCompetence"].split(".")[1]) - 5) >= 2 ? 1 : 0);
          attitudeResult.push(Math.abs(parseInt(res[key]["culturalProficiency"].split(".")[1]) - 6) >= 2 ? 1 : 0);
        } else if (res[key]["topic"] == "Empathy") {
          empathyResult.push("Empathy");
          arr.push("Empathy");
          arr.push(res[key]["culturalDestructiveness"]);
          arr.push(res[key]["culturalIncapacity"]);
          arr.push(res[key]["culturalBlindness"]);
          arr.push(res[key]["culturalPreCompetence"]);
          arr.push(res[key]["culturalCompetence"]);
          arr.push(res[key]["culturalProficiency"]);

          empathyResult.push(Math.abs(parseInt(res[key]["culturalDestructiveness"].split(".")[1]) - 1) >= 2 ? 1 : 0);
          empathyResult.push(Math.abs(parseInt(res[key]["culturalIncapacity"].split(".")[1]) - 2) >= 2 ? 1 : 0);
          empathyResult.push(Math.abs(parseInt(res[key]["culturalBlindness"].split(".")[1]) - 3) >= 2 ? 1 : 0);
          empathyResult.push(Math.abs(parseInt(res[key]["culturalPreCompetence"].split(".")[1]) - 4) >= 2 ? 1 : 0);
          empathyResult.push(Math.abs(parseInt(res[key]["culturalCompetence"].split(".")[1]) - 5) >= 2 ? 1 : 0);
          empathyResult.push(Math.abs(parseInt(res[key]["culturalProficiency"].split(".")[1]) - 6) >= 2 ? 1 : 0);
        } else if (res[key]["topic"] == "Policy") {
          policyResult.push("Policy");
          arr.push("Policy");
          arr.push(res[key]["culturalDestructiveness"]);
          arr.push(res[key]["culturalIncapacity"]);
          arr.push(res[key]["culturalBlindness"]);
          arr.push(res[key]["culturalPreCompetence"]);
          arr.push(res[key]["culturalCompetence"]);
          arr.push(res[key]["culturalProficiency"]);

          policyResult.push(Math.abs(parseInt(res[key]["culturalDestructiveness"].split(".")[1]) - 1) >= 2 ? 1 : 0);
          policyResult.push(Math.abs(parseInt(res[key]["culturalIncapacity"].split(".")[1]) - 2) >= 2 ? 1 : 0);
          policyResult.push(Math.abs(parseInt(res[key]["culturalBlindness"].split(".")[1]) - 3) >= 2 ? 1 : 0);
          policyResult.push(Math.abs(parseInt(res[key]["culturalPreCompetence"].split(".")[1]) - 4) >= 2 ? 1 : 0);
          policyResult.push(Math.abs(parseInt(res[key]["culturalCompetence"].split(".")[1]) - 5) >= 2 ? 1 : 0);
          policyResult.push(Math.abs(parseInt(res[key]["culturalProficiency"].split(".")[1]) - 6) >= 2 ? 1 : 0);
        } else if (res[key]["topic"] == "Professionalism") {
          profResult.push("Professionalism");
          arr.push("Professionalism");
          arr.push(res[key]["culturalDestructiveness"]);
          arr.push(res[key]["culturalIncapacity"]);
          arr.push(res[key]["culturalBlindness"]);
          arr.push(res[key]["culturalPreCompetence"]);
          arr.push(res[key]["culturalCompetence"]);
          arr.push(res[key]["culturalProficiency"]);

          profResult.push(Math.abs(parseInt(res[key]["culturalDestructiveness"].split(".")[1]) - 1) >= 2 ? 1 : 0);
          profResult.push(Math.abs(parseInt(res[key]["culturalIncapacity"].split(".")[1]) - 2) >= 2 ? 1 : 0);
          profResult.push(Math.abs(parseInt(res[key]["culturalBlindness"].split(".")[1]) - 3) >= 2 ? 1 : 0);
          profResult.push(Math.abs(parseInt(res[key]["culturalPreCompetence"].split(".")[1]) - 4) >= 2 ? 1 : 0);
          profResult.push(Math.abs(parseInt(res[key]["culturalCompetence"].split(".")[1]) - 5) >= 2 ? 1 : 0);
          profResult.push(Math.abs(parseInt(res[key]["culturalProficiency"].split(".")[1]) - 6) >= 2 ? 1 : 0);
        } else if (res[key]["topic"] == "Teaching Practice") {
          arr.push("Teaching Pracice");
          arr.push(res[key]["culturalDestructiveness"]);
          arr.push(res[key]["culturalIncapacity"]);
          arr.push(res[key]["culturalBlindness"]);
          arr.push(res[key]["culturalPreCompetence"]);
          arr.push(res[key]["culturalCompetence"]);
          arr.push(res[key]["culturalProficiency"]);
          teachingResult.push("Teaching Practice");
          teachingResult.push(Math.abs(parseInt(res[key]["culturalDestructiveness"].split(".")[1]) - 1) >= 2 ? 1 : 0);
          teachingResult.push(Math.abs(parseInt(res[key]["culturalIncapacity"].split(".")[1]) - 2) >= 2 ? 1 : 0);
          teachingResult.push(Math.abs(parseInt(res[key]["culturalBlindness"].split(".")[1]) - 3) >= 2 ? 1 : 0);
          teachingResult.push(Math.abs(parseInt(res[key]["culturalPreCompetence"].split(".")[1]) - 4) >= 2 ? 1 : 0);
          teachingResult.push(Math.abs(parseInt(res[key]["culturalCompetence"].split(".")[1]) - 5) >= 2 ? 1 : 0);
          teachingResult.push(Math.abs(parseInt(res[key]["culturalProficiency"].split(".")[1]) - 6) >= 2 ? 1 : 0);
        }

        this.boldList.push(arr);
      }
      this.finalList.push(attitudeResult);
      this.finalList.push(empathyResult);
      this.finalList.push(policyResult);
      this.finalList.push(profResult);
      this.finalList.push(teachingResult);
    });
    this.finalList.splice(0, 1);
    this.boldList.splice(0, 1);
    // this.getAllIndexes(this.finalList,1)
  }

  emoji: any;
  changeEmojiSize(data) {
    document.getElementById("angry").style.height = "30px";
    document.getElementById("angry").style.width = "30px";
    document.getElementById("sad").style.height = "30px";
    document.getElementById("sad").style.width = "30px";
    document.getElementById("neutral").style.height = "30px";
    document.getElementById("neutral").style.width = "30px";
    document.getElementById("smile").style.height = "30px";
    document.getElementById("smile").style.width = "30px";
    document.getElementById("heart").style.height = "30px";
    document.getElementById("heart").style.width = "30px";
    document.getElementById(data).style.height = "50px";
    document.getElementById(data).style.width = "50px";

    this.emoji = data;
  }

  thumbs: any;
  changeThumbsSize(data) {
    document.getElementById("thumbsup").style.height = "30px";
    document.getElementById("thumbsup").style.width = "30px";
    document.getElementById("thumbsdown").style.height = "30px";
    document.getElementById("thumbsdown").style.width = "30px";

    document.getElementById(data).style.height = "50px";
    document.getElementById(data).style.width = "50px";
    this.thumbs = data;
  }
  finalSubmit() {
    this.finalFeedbackForm.value["q6"] = this.thumbs;
    this.finalFeedbackForm.value["q7"] = this.emoji;

    this.endTime = new Date();

    this.durationTime = (this.endTime - this.startTime) / 1000;
    this.durationTime = this.durationTime / 60;

    this.apiService.patchStatus("finalfeedbackstatus").subscribe((res) => {});

    this.apiService.postFeedbackForm(this.finalFeedbackForm.value).subscribe(
      (res) => {
        this.apiService.changeCPCQStatus().subscribe((res1) => {
          Swal.fire({
            text: "Submitted",
            icon: "success",
          }).then((res) => {
            if (res["isConfirmed"]) {
              this.router.navigateByUrl("/result");
            }
          });
        });
      },
      (err) => {}
    );
  }
  ngOnInit(): void {
    this.startTime = new Date();
    this.finalFeedbackForm = this.fb.group({
      q1: [""],
      q2: [""],
      q3: [""],
      q4: [""],
      q5: [""],
      q6: [""],
      q7: [""],
    });

    this.apiService.attitudeData().subscribe(
      (res) => {
        //
        this.attitude = res[0];
        //
      },
      (err) => {}
    );

    this.apiService.empathyData().subscribe(
      (res) => {
        //
        this.empathy = res[0];
        //
      },
      (err) => {}
    );

    this.apiService.policyData().subscribe(
      (res) => {
        this.policy = res[0];
      },
      (err) => {}
    );

    this.apiService.professionalismData().subscribe(
      (res) => {
        this.professionalism = res[0];
      },
      (err) => {}
    );

    this.apiService.teachingData().subscribe(
      (res) => {
        this.teachingPractice = res[0];
      },
      (err) => {}
    );

    this.attitudeForm = this.fb.group({
      A: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      B: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      C: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      D: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      E: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      F: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      description: ["", [Validators.required]],
    });

    this.empathyForm = this.fb.group({
      A: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      B: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      C: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      D: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      E: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      F: ["", [Validators.minLength(1), Validators.maxLength(1)]],
    });

    this.policyForm = this.fb.group({
      A: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      B: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      C: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      D: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      E: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      F: ["", [Validators.minLength(1), Validators.maxLength(1)]],
    });

    var arr = [];
    var arr1 = [];
    var arr2 = [];
    var i;
    for (var j = 0; j < 5; j++) {
      arr = [];
      arr1 = [];
      arr2 = [];
      i = 0;
      while (i < 6) {
        var item1 = Math.floor(Math.random() * (7 - 1) + 1);
        if (arr1.indexOf(item1) == -1) {
          if (i == 0) {
            arr.push(this.attributes[j]);
            arr.push(this.rowLetters[j][i] + ". " + item1);
            arr1.push(item1);
            if (arr1[arr1.length - 1] > 2) {
              //
              arr2.push("True");
            } else {
              arr2.push("False");
            }
          } else {
            arr.push(this.rowLetters[j][i] + ". " + item1);
            arr1.push(item1);
            if (i == 1) {
              if (arr1[arr1.length - 1] > 3) {
                arr2.push("True");
              } else {
                arr2.push("False");
              }
            } else if (i == 2) {
              if (arr1[arr1.length - 1] > 4 || arr1[arr1.length - 1] == 1) {
                arr2.push("True");
              } else {
                arr2.push("False");
              }
            } else if (i == 3) {
              if (arr1[arr1.length - 1] > 5 || arr1[arr1.length - 1] < 4) {
                arr2.push("True");
              } else {
                arr2.push("False");
              }
            } else if (i == 4) {
              if (arr1[arr1.length - 1] < 4) {
                arr2.push("True");
              } else {
                arr2.push("False");
              }
            } else if (i == 5) {
              if (arr1[arr1.length - 1] < 5) {
                arr2.push("True");
              } else {
                arr2.push("False");
              }
            }
          }
          i = i + 1;
        } else {
          continue;
        }
      }
      this.formValues.push(arr);
      this.boldList.push(arr1);
      this.randomList.push(arr2);
    }
    this.boldList.splice(0, 1);
    this.randomList.splice(0, 1);

    this.getAllIndexes(this.randomList, "True");
    this.loaded = true;
  }

  getAllIndexes(arr, val) {
    var indexes = [];
    var i = -1;
    for (var i = 0; i < arr.length; i++) {
      for (var j = 0; j < arr[i].length; j++) {
        if (arr[i][j] == "True") {
          var arr1 = [];
          arr1.push(i);
          arr1.push(j);
          indexes.push(arr1);
        }
      }
    }

    var arr1 = [];
    for (var i = 0; i < indexes.length; i++) {
      arr1.push(i);
    }
    var ranNums = [];
    var i = arr1.length;
    var j = 0;
    var count = 0;
    while (i--) {
      if (count < 5) {
        j = Math.floor(Math.random() * (i + 1));
        ranNums.push(arr1[j]);
        arr1.splice(j, 1);
        count = count + 1;
      } else {
        break;
      }
    }

    //
    for (var i = 0; i < this.boldList.length; i++) {
      var temp = [];
      for (var j = 0; j < 6; j++) {
        temp.push("False");
      }
      this.finalList1.push(temp);
    }

    for (var i = 0; i < ranNums.length; i++) {
      var item = indexes[ranNums[i]];

      this.finalList1[item[0]][item[1]] = "True";
    }
    // this.finalList1.splice(0,1)
  }
  preSurvey() {
    this.router.navigateByUrl("/preSurvey");
  }

  nextButton() {
    if (this.selectedIndex == 0) {
      this.selectedIndex = this.selectedIndex + 1;
      return;
    }
    if (this.selectedIndex == 7) {
      this.router.navigateByUrl("/dashboard");
      return;
    }

    var numberList = [];
    var flag = true;
    for (let key in this.attitudeForm.value) {
      if ((this.attitudeForm.value[key] > 6 || this.attitudeForm.value[key] < 1) && key != "description") {
        flag = false;
        Swal.fire({
          text: "Please enter values from 1 through 6 only.",
          icon: "warning",
        }).then((res) => {});
        break;
      }
      if (numberList.indexOf(this.attitudeForm.value[key]) == -1) {
        numberList.push(this.attitudeForm.value[key]);
      } else {
        flag = false;
        Swal.fire({
          text: "The inputs have been repeated. Please enter values from 1 through 6.",
          icon: "warning",
        }).then((res) => {});
        break;
      }
    }
    if (!this.buttonClick) {
      flag = false;
      Swal.fire({
        text: "Click on the word '" + this.attributes[this.selectedIndex - 1] + "' and respond to the prompt.",
        icon: "warning",
      }).then((res) => {});
    }
    if (flag) {
      if (this.selectedIndex == 7) {
        this.router.navigateByUrl("/postSurvey");
      }
      this.sliderFunction1();
      var formData = {};
      formData["topic"] = this.attributes[this.selectedIndex - 1];
      if (this.attributes[this.selectedIndex - 1] == "Attitude") {
        formData["culturalDestructiveness"] = "D. " + this.attitudeForm.value["D"];
        formData["culturalIncapacity"] = "C. " + this.attitudeForm.value["C"];
        formData["culturalBlindness"] = "B. " + this.attitudeForm.value["B"];
        formData["culturalPreCompetence"] = "A. " + this.attitudeForm.value["A"];
        formData["culturalCompetence"] = "F. " + this.attitudeForm.value["F"];
        formData["culturalProficiency"] = "E. " + this.attitudeForm.value["E"];
      } else if (this.attributes[this.selectedIndex - 1] == "Empathy") {
        formData["culturalDestructiveness"] = "E. " + this.attitudeForm.value["E"];
        formData["culturalIncapacity"] = "A. " + this.attitudeForm.value["A"];
        formData["culturalBlindness"] = "F. " + this.attitudeForm.value["F"];
        formData["culturalPreCompetence"] = "D. " + this.attitudeForm.value["D"];
        formData["culturalCompetence"] = "B. " + this.attitudeForm.value["B"];
        formData["culturalProficiency"] = "C. " + this.attitudeForm.value["C"];
      } else if (this.attributes[this.selectedIndex - 1] == "Policy") {
        formData["culturalDestructiveness"] = "F. " + this.attitudeForm.value["F"];
        formData["culturalIncapacity"] = "E. " + this.attitudeForm.value["E"];
        formData["culturalBlindness"] = "B. " + this.attitudeForm.value["B"];
        formData["culturalPreCompetence"] = "C. " + this.attitudeForm.value["C"];
        formData["culturalCompetence"] = "D. " + this.attitudeForm.value["D"];
        formData["culturalProficiency"] = "A. " + this.attitudeForm.value["A"];
      } else if (this.attributes[this.selectedIndex - 1] == "Professionalism") {
        formData["culturalDestructiveness"] = "E. " + this.attitudeForm.value["E"];
        formData["culturalIncapacity"] = "A. " + this.attitudeForm.value["A"];
        formData["culturalBlindness"] = "B. " + this.attitudeForm.value["B"];
        formData["culturalPreCompetence"] = "D. " + this.attitudeForm.value["D"];
        formData["culturalCompetence"] = "C. " + this.attitudeForm.value["C"];
        formData["culturalProficiency"] = "F. " + this.attitudeForm.value["F"];
      } else if (this.attributes[this.selectedIndex - 1] == "Teaching Practice") {
        formData["culturalDestructiveness"] = "D. " + this.attitudeForm.value["D"];
        formData["culturalIncapacity"] = "C. " + this.attitudeForm.value["C"];
        formData["culturalBlindness"] = "B. " + this.attitudeForm.value["B"];
        formData["culturalPreCompetence"] = "E. " + this.attitudeForm.value["E"];
        formData["culturalCompetence"] = "A. " + this.attitudeForm.value["A"];
        formData["culturalProficiency"] = "F. " + this.attitudeForm.value["F"];
      }

      this.endTime = new Date();

      this.durationTime = (this.endTime - this.startTime) / 1000;
      this.durationTime = this.durationTime / 60;

      formData["description"] = this.wordDescription;
      formData["duration"] = this.durationTime;
      this.apiService.postFormData(formData).subscribe(
        (res) => {
          //
        },
        (err) => {}
      );
      // this.getForm();
      this.selectedIndex = this.selectedIndex + 1;
      this.buttonClick = false;
      this.startTime = new Date();
      this.attitudeForm = this.fb.group({
        A: ["", [Validators.minLength(1), Validators.maxLength(1)]],
        B: ["", [Validators.minLength(1), Validators.maxLength(1)]],
        C: ["", [Validators.minLength(1), Validators.maxLength(1)]],
        D: ["", [Validators.minLength(1), Validators.maxLength(1)]],
        E: ["", [Validators.minLength(1), Validators.maxLength(1)]],
        F: ["", [Validators.minLength(1), Validators.maxLength(1)]],
      });
    }
  }

  postSurvey() {
    this.router.navigateByUrl("/postSurvey");
  }

  submitForm1() {
    if (this.unpackedCount >= 5) {
      this.endTime = new Date();

      this.durationTime = (this.endTime - this.startTime) / 1000;
      this.durationTime = this.durationTime / 60;
      this.apiService.patchStatus("cpcqstatus").subscribe((res) => {
        Swal.fire({
          text: "Submitted",
          icon: "success",
        }).then((res) => {
          if (res["isConfirmed"]) {
            // this.getForm()
            this.selectedIndex = this.selectedIndex + 1;
          }
        });
      });
    } else {
      Swal.fire({
        text: "Please click on all the yellow boxes and answer the questions in the prompt.",
        icon: "warning",
      }).then((res) => {});
    }
  }

  submitForm() {
    if (this.selectedIndex == 5) {
      var numberList = [];
      var flag = false;

      for (let key in this.attitudeForm.value) {
        if ((this.attitudeForm.value[key] > 6 || this.attitudeForm.value[key] < 1) && key != "description") {
          flag = true;
          Swal.fire({
            text: "Please enter values from 1 through 6 only.",
            icon: "warning",
          }).then((res) => {});
          break;
        }
        if (numberList.indexOf(this.attitudeForm.value[key]) == -1) {
          numberList.push(this.attitudeForm.value[key]);
        } else {
          flag = true;
          Swal.fire({
            text: "The inputs have been repeated. Please enter values from 1 through 6.",
            icon: "warning",
          }).then((res) => {});
          break;
        }
      }
      if (!this.buttonClick) {
        flag = true;
        Swal.fire({
          text: "Click on the word '" + this.attributes[this.selectedIndex - 1] + "' and respond to the prompt.",
          icon: "warning",
        }).then((res) => {});
      }
      if (!flag) {
        //
        var formData = {};

        formData["topic"] = this.attributes[this.selectedIndex - 1];
        formData["culturalDestructiveness"] = "D. " + this.attitudeForm.value["D"];
        formData["culturalIncapacity"] = "C. " + this.attitudeForm.value["C"];
        formData["culturalBlindness"] = "B. " + this.attitudeForm.value["B"];
        formData["culturalPreCompetence"] = "E. " + this.attitudeForm.value["E"];
        formData["culturalCompetence"] = "A. " + this.attitudeForm.value["A"];
        formData["culturalProficiency"] = "F. " + this.attitudeForm.value["F"];

        formData["description"] = this.wordDescription;
        this.endTime = new Date();

        this.durationTime = (this.endTime - this.startTime) / 1000;
        this.durationTime = this.durationTime / 60;

        formData["duration"] = this.durationTime;
        this.apiService.postFormData(formData).subscribe(
          (res) => {
            //
            this.apiService.patchStatus("responsesstatus").subscribe((res) => {
              Swal.fire({
                text: "Submitted",
                icon: "success",
              }).then((res) => {
                if (res["isConfirmed"]) {
                  // this.getForm()
                  // this.getResponses()
                  this.router.navigateByUrl("/unpacking");

                  // this.selectedIndex = this.selectedIndex + 1;
                  this.startTime = new Date();
                }
              });
            });
          },
          (err) => {}
        );
      }
    }
  }

  submit() {
    //
    var tempDict;
    this.responseList = [];
    for (let key in this.firstForm.value) {
      tempDict = {};
      tempDict["question"] = key;
      tempDict["response"] = this.firstForm.value[key];
      this.responseList.push(tempDict);
    }
    //

    this.formService.submitResponse(this.responseList).subscribe(
      (res) => {
        //
        Swal.fire({
          text: "Submitted",
          icon: "success",
        });
        this.router.navigateByUrl("/game");
      },
      (err) => {
        Swal.fire({
          text: "Duplicate Entries",
          icon: "warning",
        });
      }
    );
  }

  title = "micRecorder";
  //Lets declare Record OBJ
  record;
  //Will use this flag for toggeling recording
  recording = false;
  //URL of Blob
  url;
  error;
  sanitize(url: string) {
    return this.domSanitizer.bypassSecurityTrustUrl(url);
  }
  /**
   * Start recording.
   */
  initiateRecording() {
    this.recording = true;
    let mediaConstraints = {
      video: false,
      audio: true,
    };
    navigator.mediaDevices
      .getUserMedia(mediaConstraints)
      .then(this.successCallback.bind(this), this.errorCallback.bind(this));
  }
  /**
   * Will be called automatically.
   */
  successCallback(stream) {
    var options = {
      mimeType: "audio/wav",
      numberOfAudioChannels: 1,
      // sampleRate: 16000,
    };
    //Start Actuall Recording
    var StereoAudioRecorder = RecordRTC.StereoAudioRecorder;
    this.record = new StereoAudioRecorder(stream, options);
    this.record.record();
  }
  /**
   * Stop recording.
   */
  stopRecording() {
    this.recording = false;
    this.record.stop(this.processRecording.bind(this));
  }
  /**
   * processRecording Do what ever you want with blob
   * @param  {any} blob Blog
   */
  processRecording(blob) {
    this.url = URL.createObjectURL(blob);
    //
    //
  }
  /**
   * Process Error.
   */
  errorCallback(error) {
    this.error = "Can not play audio in your browser";
  }
}
