import { Injectable } from "@angular/core";
import { ActivatedRouteSnapshot, CanActivate, Router, RouterStateSnapshot } from "@angular/router";
import { LoginService } from "../services/login.service";

@Injectable({
  providedIn: "root",
})
export class RoleGuard implements CanActivate {
  constructor(private loginService: LoginService, private _router: Router) {}

  canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): Promise<boolean> {
    return new Promise((resolve, reject) => {
      this.loginService.getToken().subscribe({
        next: (token) => {
          console.log(token);
          // implement role check functionalities
          if (token) {
            resolve(true);
          } else {
            resolve(false);
          }
        },
        error: (error) => {
          console.log(error);
          resolve(false);
        },
      });
    });
  }
}
