import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { from, Observable } from "rxjs";
import { LoginService } from "../services/login.service";

@Injectable()
export class TokenInterceptor implements HttpInterceptor {
  constructor(private loginService: LoginService) {}

  intercept(request: HttpRequest<unknown>, next: HttpHandler): Observable<HttpEvent<unknown>> {
    console.log("i am token interceptor");
    return from(this.handleIntercept(request, next));
  }

  private async handleIntercept(request: HttpRequest<any>, next: HttpHandler): Promise<HttpEvent<any>> {
    const token = await this.loginService.getToken().toPromise();
    console.log("token is", token);
    if (token) {
      request = request.clone({ headers: request.headers.set("Authorization", "Bearer " + token) });
    }
    return next.handle(request).toPromise();
  }
}
