import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { environment } from "src/environments/environment";

@Injectable({
  providedIn: "root",
})
export class CPCQService {
  baseUri = environment.apiUrl;
  cpcqUrl = environment.cqcqUrl;

  constructor(private http: HttpClient) {}

  attitudeData() {
    return this.http.get(`${this.baseUri}/attitude`);
  }

  empathyData() {
    return this.http.get(`${this.baseUri}/empathy`);
  }

  policyData() {
    return this.http.get(`${this.baseUri}/policy`);
  }

  professionalismData() {
    return this.http.get(`${this.baseUri}/professionalism`);
  }

  teachingData() {
    return this.http.get(`${this.baseUri}/teaching`);
  }

  changeCPCQStatus() {
    return this.http.post(`${this.cpcqUrl}`, { choices: "Finished All Forms" });
  }

  getCPCQStatus() {
    return this.http.get(`${this.cpcqUrl}`);
  }

  postFormData(data) {
    return this.http.post(`${this.baseUri}/responses`, data);
  }

  postFeedbackForm(data) {
    return this.http.post(`${this.baseUri}/finalFeedback`, data);
  }

  getFormData() {
    return this.http.get(`${this.baseUri}/responses`);
  }

  getResponsesData() {
    return this.http.get(`${this.baseUri}/responses_all/`);
  }

  postUnpacking(data) {
    return this.http.post(`${this.baseUri}/cpcq_response`, data);
  }

  getScoreInfo() {
    return this.http.get(`${this.baseUri}/cpcq_response`);
  }

  getScoreVisualization() {
    return this.http.get(`${this.baseUri}/graphs`);
  }

  patchStatus(data) {
    return this.http.patch(`${this.baseUri}/status/?value=${data}`, {});
  }
}
