import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { environment } from "src/environments/environment";

@Injectable({
  providedIn: "root",
})
export class PreSurveyService {
  baseUrl = environment.apiUrl;
  preSurveys = environment.preSurveyUrl;
  profileUrl = environment.profileUrl;
  userUrl = environment.userUrl;
  postSurveyUrl = environment.postSurveyUrl;

  constructor(private http: HttpClient) {}

  submitForm(data) {
    return this.http.post(`${this.preSurveys}`, data);
  }

  postProfile(data) {
    return this.http.patch(`${this.profileUrl}`, data);
  }

  getPreSurveyAnswer() {
    return this.http.get(`${this.preSurveys}`);
  }

  profileData() {
    return this.http.get(`${this.profileUrl}`);
  }

  userData() {
    return this.http.get(`${this.userUrl}`);
  }

  submitPostSurvey(data) {
    return this.http.post(`${this.postSurveyUrl}`, data);
  }

  getFormData() {
    return this.http.get(`${this.userUrl}`);
  }

  getFormQuestions() {
    return this.http.get(`${this.baseUrl}` + "presurvey_questions/");
  }

  getPostSurveyFormQuestions() {
    return this.http.get(`${this.baseUrl}` + "postsurvey_questions/");
  }
}
